<?php
//  PROXY
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: pnpproxy.inc.php 59 2010-03-08 22:56:21Z egalstad $

require_once(dirname(__FILE__).'/../componenthelper.inc.php');


function pnp_do_proxy($urlpart="",$queryargs=null){
	global $cfg;
	global $request;

	// check authentication
	check_authentication(false);
	
	$username=get_component_credential("pnp","username");
	$password=get_component_credential("pnp","password");

	$url="http://";
	if(have_value($username)==true){
		$url.=$username;
		$url.=":";
		$url.=$password;
		$url.="@";
		}
	$url.="localhost"; // machine name
	
	if($urlpart==""){
		$url.=$cfg['component_info']['pnp']['direct_url'];
		$url.="/";
		$url.=$file;
		}
	else
		$url.=$urlpart;
	
	// remove request vars we don't want the url or method passed to the remote host
	//unset($request["somevar"]);
	
	// build url from array of arguments
	if($queryargs==null)
		$queryargs=$request;
	if($queryargs!="")
		$theurl=$url."?".http_build_query($queryargs);
	
	$options = array(
		'return_info'	=> true,
		'method'	=> 'get'
		);
		
	//echo "PNPPROXYURL: $url<BR>";
	//exit();
		
	// fetch the url
	$result=load_url($theurl,$options);
	//print_r($result);
	//exit();

	$headers=$result["headers"];
	//echo "HEADERS:<R>";
	//print_r($headers);
	$contenttype="";
	if(array_key_exists("Content-Type",$headers))
		$contenttype=$headers["Content-Type"];
	//print_r($contenttype);
	if(!have_value($contenttype))
		$contenttype="text/html";

	//echo "USING TYPE: $contenttype";
	//exit;

	header("Content-Type: $contenttype");
	echo $result["body"];
	}
?>