<?php
// XI Core Ajax Helper Functions
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: ajaxhelpers-misc.inc.php 59 2010-03-08 22:56:21Z egalstad $

include_once(dirname(__FILE__).'/../componenthelper.inc.php');
	

////////////////////////////////////////////////////////////////////////
// MISC AJAX FUNCTIONS
////////////////////////////////////////////////////////////////////////
	
function xicore_ajax_get_xi_news_feed_html($args=null){
	global $lstr;
	
	$output='';

	$output.='
	<table class="infotable">
	<thead>
	<tr><th>&nbsp;</th></tr>
	</thead>
	<tbody>
	';
	
	$output.="<tr><td>";
	$output.="<ul>";
	
	// where do we get news from
	$url="http://www.nagios.com/backend/feeds/products/nagiosxi/";
	
	$update_news=false;
	$news=array();
	$newsraw=get_meta(METATYPE_NONE,0,"xinews");
	if($newsraw==null || have_value($newsraw)==false)
		$update_news=true;
	else{
	
		$news=unserialize($newsraw);
		
		// is it time to update the news? */
		$now=time();
		if(($now-intval($news["time"])) > 60*60*24)
			$update_news=true;
			
		//print_r($news);
		}
		
	$update_news=true;
	
	// fetch new news
	if($update_news==true){
	
		// fetch news
		$rss=simplexml_load_file($url);
		//$rss=new SimpleXMLElement($url,LIBXML_NOCDATA,true);
		//print_r($rss);
		
		$newsitems=array();
		foreach($rss->channel->item as $i){
			$newsitems[]=array(
				"link" => strval($i->link),
				"title" => strval($i->title),
				"description" => strval($i->description),		
				);
			}
		
		// cache news
		$news["time"]=time();
		//$news["rss"]=json_encode($rss);
		$news["rss"]=json_encode($newsitems);
		//print_r($news);
		set_meta(METATYPE_NONE,0,"xinews",serialize($news));
		$newsitems_s=json_decode($news["rss"]);
		$newsitems=(array)$newsitems_s;
		}
		
	// use cached news
	else{
		//print_r($newsraw);
		$news=unserialize($newsraw);
		$newsitems_s=json_decode($news["rss"]);
		$newsitems=(array)$newsitems_s;
		}
	
	
	
	$x=0;
	//print_r($newsitems);
	foreach($newsitems as $is){
		$x++;
		if($x>3)
			break;
		$i=(array)$is;
		$link=strval($i["link"]);
		$title=strval($i["title"]);
		$description=strval($i["description"]);
		$output.="<li><a href='".$link."' target='_blank'>".$title."</a><br>".$description."</li>";
		}

		
	$output.="</ul>";
	$output.="</td></tr>";
		
	$output.='
	</tbody>
	</table>
	';
			
	return $output;
	}
	
	

function xicore_ajax_get_available_updates_html($args=null){
	global $lstr;
	
	// check for updates
	do_update_check();
	
	$update_info=array(
		"last_update_check_time" => get_option("last_update_check_time"),
		"last_update_check_succeeded" => get_option("last_update_check_succeeded"),
		"update_available" => get_option("update_available"),
		"update_version" => get_option("update_version"),
		"update_release_date" => get_option("update_release_date"),
		"update_release_notes" => get_option("update_release_notes"),
		);
		
	//print_r($update_info);
	
	if($update_info["last_update_check_succeeded"]==0){
		$update_str="<p><div style='float: left; margin-right: 10px;'><img src='".theme_image("unknown_small.png")."'></div><b>Update Check Problem: Last update check failed.</b></p>";
		}
	else if($update_info["update_available"]==1){
		$update_str="<p><div style='float: left; margin-right: 10px;'><img src='".theme_image("critical_small.png")."'></div><b>A new Nagios XI update is available.</b></p>";
		
		if($update_info["update_release_notes"]!="")
			$update_str.="<p>".$update_info["update_release_notes"];
		
		$update_str.="<p>Visit <a href='http://www.nagios.com/products/nagiosxi/' target='_blank'>www.nagios.com</a> to obtain the latest update.</p>";
		}
	else{
		$update_str="<p><div style='float: left; margin-right: 10px;'><img src='".theme_image("ok_small.png")."'></div><b>Your Nagios XI installation is up to date.</b></p>";
		}
	//$update_str.="<BR><BR>";
	
	$output='';
	
	$output.='
	<table class="infotable">
	<tbody>
	';
	
	$output.='<tr><td colspan="2">'.$update_str.'</td></tr>';

	$output.='<tr><td>Latest Available Version:</td><td>'.$update_info["update_version"].'</td></tr>';
	$output.='<tr><td>Installed Version:</td><td>'.get_product_version().'</td></tr>';
	$output.='<tr><td>Last Update Check:</td><td>'.get_datetime_string($update_info["last_update_check_time"]).'</td></tr>';
			
	$output.='
	</tbody>
	</table>
	';
			
	$output.='
	<div class="ajax_date">Last Updated: '.get_datetime_string(time()).'</div>
	';

	return $output;
	}
	
	
	
?>