<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// $Id: pageparts.inc.php 59 2010-03-08 22:56:21Z egalstad $

include_once(dirname(__FILE__).'/utils.inc.php');
include_once(dirname(__FILE__).'/auth.inc.php');
include_once(dirname(__FILE__).'/components.inc.php');


function do_page_start($opts=null,$child=false){

	if($opts==null)
		$opts=array();

	// what title should be used for the page?
	$title="";
	if(isset($opts["page_title"]))
		$title=$opts["page_title"];
	$pagetitle=get_product_name();
	if($title!="")
		$pagetitle.=" - $title";
		
	// body id
	$bid="";
	$body_id="";
	if(isset($opts["body_id"]))
		$bid=$opts["body_id"];
	if($bid!="")
		$body_id=" id='$bid'";
	
	// body class
	$bc="";
	$body_class="";
	if(isset($opts["body_class"]))
		$bc=$opts["body_class"];
	if($bc!="")
		$body_class=" class='$bc'";
	
	// body style
	$bs="";
	$body_style="";
	if(isset($opts["body_style"]))
		$bs=$opts["body_style"];
	if($bs!="")
		$body_style=" style='$bs'";
	
	// page id
	$pid="";
	$page_id="";
	if(isset($opts["page_id"]))
		$pid=$opts["page_id"];
	if($pid!="")
		$page_id=" id='$pid'";
		
	// page class
	$page_class="parentpage";
	if($child==true)
		$page_class="childpage";
	$pc="";
	if(isset($opts["page_class"]))
		$pc=$opts["page_class"];
	if($pc!="")
		$page_class.=" $pc";
	
	if($child==false){
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">
<?php
		}
	else{
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<?php
//<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

		}
?>

<html>
	<!-- Produced by Nagios XI.  Copyyright (c) 2008-2009 Nagios Enterprises, LLC (www.nagios.com). All Rights Reserved. -->
	<!-- Powered by the Nagios Synthesis Framework -->
	<head>
	<title><?php echo $pagetitle;?></title>
	<meta name="ROBOTS" content="NOINDEX, NOFOLLOW">
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<?php do_page_head_links();?>
	<?php do_callbacks(CALLBACK_PAGE_HEAD,array("child"=>$child));?>
</head>


<body <?php echo $body_id;?><?php echo $body_class;?> <?php echo $body_style;?>>

	<?php do_callbacks(CALLBACK_BODY_START,array("child"=>$child));?>
	
	<div <?php echo $page_id;?> class="<?php echo $page_class;?>"><!-- page-->

		<div id="header">
<?php
		do_page_header($child);
		if($child==false){
?>
		<div id="throbber"></div>
<?php
		}
?>
		</div><!--header -->


<?php 
	$throbber_image=get_base_url()."images/throbber1.gif";
	if($child==false){
?>
	<div id="mainframe">
	<div id="parentcontentthrobber"><img src='<?php echo $throbber_image;?>' /></div>
<?php
		if(is_authenticated()==true){
			$page=get_current_page();
			if($page!=PAGEFILE_LOGIN && $page!=PAGEFILE_INSTALL){
?>
	<div id="fullscreen"></div>
<?php
				}
			}
		}
	else{
?>
	<div id="childcontentthrobber"><img src='<?php echo $throbber_image;?>' /></div>
<?php
		}
		
	do_callbacks(CALLBACK_CONTENT_START,array("child"=>$child));
	}
	
	
function do_page_head_links(){

	$base_url=get_base_url();
?>
	<link rel="shortcut icon" href="<?php echo $base_url;?>images/favicon.ico" type="image/ico">
	<LINK REL='stylesheet' TYPE='text/css' HREF='<?php echo $base_url;?>includes/css/jquery.autocomplete.css'>
	
	<script type='text/javascript'>
		var base_url="<?php echo $base_url;?>";
		var backend_url="<?php echo get_backend_url(false);?>";
		var ajax_helper_url="<?php echo get_ajax_helper_url();?>";
		var ajax_proxy_url="<?php echo get_ajax_proxy_url();?>";
		var suggest_url="<?php echo get_suggest_url();?>";
		var request_uri="<?php echo $_SERVER["REQUEST_URI"];?>";
		var permalink_base="<?php echo get_permalink_base();?>";
		var demo_mode=<?php echo (in_demo_mode()==true)?1:0;?>;
	</script>

<!-- FIREBUG LITE! -->	
<!--
<script type='text/javascript' 
        src='http://getfirebug.com/releases/lite/1.2/firebug-lite-compressed.js'></script>
//-->	

	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery-current.min.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery.colorBlend.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery.checkboxes.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery.autocomplete.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery.easydrag.js'></script>
	<!--<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery.timer.js'></script>-->
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery.timers-1.1.3.js'></script>

	<!-- this causes problems with sparkline! -->
	<!--<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery.dimensions.pack.js'></script>-->
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery.bgiframe.pack.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery.tooltip.pack.js'></script>

	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery.sparkline.js'></script>
	
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/jquery/jquery-ui-1.7.2.custom.min.js'></script>
	<link type="text/css" href="<?php echo $base_url;?>includes/js/jquery/css/smoothness/jquery-ui-1.7.2.custom.css" rel="stylesheet" />
	
	<!-- colorpicker -->
	<link rel="stylesheet" href="<?php echo $base_url;?>includes/js/jquery/colorpicker/css/colorpicker.css" type="text/css" />
	<!--
    <link rel="stylesheet" media="screen" type="text/css" href="<?php echo $base_url;?>includes/js/jquery/colorpicker/css/layout.css" />
	//-->
	<script type="text/javascript" src="<?php echo $base_url;?>includes/js/jquery/colorpicker/js/colorpicker.js"></script>
	<!--
    <script type="text/javascript" src="<?php echo $base_url;?>includes/js/jquery/colorpicker/js/eye.js"></script>
    <script type="text/javascript" src="<?php echo $base_url;?>includes/js/jquery/colorpicker/js/utils.js"></script>
    <script type="text/javascript" src="<?php echo $base_url;?>includes/js/jquery/colorpicker/js/layout.js?ver=1.0.2"></script>
	//-->
	<!-- colorpicker -->

	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/core.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/commands.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/views.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/dashboards.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/dashlets.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/tables.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/users.js'></script>
	<script type='text/javascript' src='<?php echo $base_url;?>includes/js/perfdata.js'></script>
	
	<LINK REL='stylesheet' TYPE='text/css' HREF='<?php echo $base_url;?>includes/css/nagiosxi.css'>
<?php
	// include css/js stuff for dashlets
	echo get_dashlets_pagepart_includes();
	}
	

function do_page_header($child){

	do_callbacks(CALLBACK_HEADER_START,array("child"=>$child));

	if($child==true)
		include_once(dirname(__FILE__).'/header-child.inc.php');
	else
		include_once(dirname(__FILE__).'/header.inc.php');

	do_callbacks(CALLBACK_HEADER_END,array("child"=>$child));
	}	

	
	
function do_page_end($child=false){
?>

	<?php do_callbacks(CALLBACK_CONTENT_END,array("child"=>$child));?>

<?php
	if($child==false){
?>
		</div><!--mainframe-->
<?php
		}
?>
	
		<div id="footer">
		<?php do_page_footer($child);?>
		</div><!--footer-->
	
	</div><!--page-->

<noframes>
<!-- This page requires a web browser which supports frames. --> 
<h2><?php echo get_product_name();?></h2>
<p align="center">
<a href="http://www.nagios.com/">www.nagios.com</a><br>
Copyright (c) 2009 Nagios Enterprises, LLC<br>
</p>
<p>
<i>Note: These pages require a browser which supports frames</i>
</p>
</noframes>

	<?php do_callbacks(CALLBACK_BODY_END,array("child"=>$child));?>

</body>

</html>
<?php
	}
	


function do_page_footer($child){

	do_callbacks(CALLBACK_FOOTER_START,array("child"=>$child));
	
	if($child==true)
		include_once(dirname(__FILE__).'/footer-child.inc.php');
	else
		include_once(dirname(__FILE__).'/footer.inc.php');
		
	do_callbacks(CALLBACK_FOOTER_END,array("child"=>$child));
	}	

	

function display_message($error=true,$info=true,$msg=""){
	if(have_value($msg)){
		if($error==true)
			$divclass="errorMessage";
		else if($info==true)
			$divclass="infoMessage";
		else
			$divclass="actionMessage";
?>
		<div id="message">
		<ul class="<?php echo $divclass;?>">
		<?php 
			if(is_array($msg)){
				foreach($msg as $m)
					echo "<li>$m</li>";
				}
			else
				echo "<li>$msg</li>";
		?>
		</ul>
		</div>
<?php
		}	
	}
	

function get_window_frame_url($default){
	global $request;
	
	// default window url may have been overridden with a permalink...
	$windowurl=grab_request_var("xiwindow",$default);
	return $windowurl;
	}

?>