<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// Development Started 03/22/2008
// $Id: utils-menu.inc.php 59 2010-03-08 22:56:21Z egalstad $

//require_once(dirname(__FILE__).'/common.inc.php');

////////////////////////////////////////////////////////////////////////
// MENU FUNCTIONS
////////////////////////////////////////////////////////////////////////

function draw_menu_items($items){
	$html=get_menu_items_html($items);
	echo $html;
	}
	
function get_menu_items_html($items){
	$html="";
	foreach($items as $item){
		$title="";
		if(array_key_exists("title",$item))
			$title=$item["title"];
		$opts="";
		if(array_key_exists("opts",$item))
			$opts=$item["opts"];
		$html.=get_menu_item_html($item["type"],$title,$opts);
		}
	return $html;
	}
	

function get_menu_item_html($type,$title,$opts){

	$html="";

	switch($type){
	
	// html
	case "html":
		$html.=$opts["html"];
		break;
	
	// menu links
	case "menusection":
		$secondclass="";
		if($opts["expanded"]==false)
			$secondclass="menusection-collapsed";
		$linkopts="";
		if(array_key_exists("linkopts",$opts))
			$linkopts=$opts["linkopts"];
		$target="";
		if(array_key_exists("target",$opts)){
			$t=$opts["target"];
			if(have_value($target))
				$target="target='".$t."'";
			}
		else
			$target="target='maincontentframe'";

		$urla="";
		$urlb="";
		if(array_key_exists("url",$opts)){
			$urla="<a href='".$opts["url"]."' ".$target." ".$linkopts.">";
			$urlb="</a>";
			}
		$html.="<div class='menusection ".$secondclass."'>";
		$html.="<div class='menusectionbutton'></div>";
		$html.="<div class='menusectiontitle'>".$urla.$title.$urlb."</div>";
		$ulopts="";
		if(array_key_exists("ulopts",$opts))
			$ulopts=$opts["ulopts"];
		$html.="<ul class='menusection' ".$ulopts.">";
		break;
	case "menusectionend":
		$html.="</ul>";
		$html.="</div>";
		break;
	case "linkspacer":
		$html.="<li class='menulinkspacer'></li>";
		break;
	case "link":
		$xopts="";
		foreach($opts as $var => $val){
			$xopts.=" ".$var."=\"".$val."\"";
			}
		// no target was specified - default it
		if(array_key_exists("target",$opts)==false){
			$xopts.=" target=\"maincontentframe\"";
			}
		// link image
		$img="";
		if(array_key_exists("img",$opts)){
			$img.="<img src='".$opts["img"]."'>";
			}
		$html.="<li class='menulink'><a ".$xopts.">".$img.$title."</a></li>";
		break;
	default:
		break;
		}
		
	return $html;
	}


?>